Description: Stop using the imp module
Author: Thomas Goirand <zigo@debian.org>
Bug-Debian: https://bugs.debian.org/1058248
Forwarded: no
Last-Update: 2023-12-13

Index: python-diskimage-builder/diskimage_builder/elements/growvols/tests/test_growvols.py
===================================================================
--- python-diskimage-builder.orig/diskimage_builder/elements/growvols/tests/test_growvols.py
+++ python-diskimage-builder/diskimage_builder/elements/growvols/tests/test_growvols.py
@@ -11,14 +11,26 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import imp
+import importlib.util
+import importlib.machinery
 import mock
 import os
+import sys
 from oslotest import base
 
+def load_source(modname, filename):
+    loader = importlib.machinery.SourceFileLoader(modname, filename)
+    spec = importlib.util.spec_from_file_location(modname, filename, loader=loader)
+    module = importlib.util.module_from_spec(spec)
+    # The module is always executed and not cached in sys.modules.
+    # Uncomment the following line to cache the module.
+    sys.modules[module.__name__] = module
+    loader.exec_module(module)
+    return module
+
 module_path = (os.path.dirname(os.path.realpath(__file__)) +
                '/../static/usr/local/sbin/growvols')
-growvols = imp.load_source('growvols', module_path)
+growvols = load_source('growvols', module_path)
 
 # output of lsblk -Po kname,pkname,name,label,type,fstype,mountpoint
 LSBLK = """KNAME="sda" PKNAME="" NAME="sda" LABEL="" TYPE="disk" FSTYPE="" MOUNTPOINT=""
Index: python-diskimage-builder/diskimage_builder/elements/package-installs/tests/test_package_squash.py
===================================================================
--- python-diskimage-builder.orig/diskimage_builder/elements/package-installs/tests/test_package_squash.py
+++ python-diskimage-builder/diskimage_builder/elements/package-installs/tests/test_package_squash.py
@@ -13,16 +13,27 @@
 #    under the License.
 import collections
 import functools
-import imp
+import importlib.util
+import importlib.machinery
 import mock
 import os
 
 from oslotest import base
 from testtools.matchers import Mismatch
 
+def load_source(modname, filename):
+    loader = importlib.machinery.SourceFileLoader(modname, filename)
+    spec = importlib.util.spec_from_file_location(modname, filename, loader=loader)
+    module = importlib.util.module_from_spec(spec)
+    # The module is always executed and not cached in sys.modules.
+    # Uncomment the following line to cache the module.
+    # sys.modules[module.__name__] = module
+    loader.exec_module(module)
+    return module
+
 installs_squash_src = (os.path.dirname(os.path.realpath(__file__)) +
                        '/../bin/package-installs-squash')
-installs_squash = imp.load_source('installs_squash', installs_squash_src)
+installs_squash = load_source('installs_squash', installs_squash_src)
 
 
 class IsMatchingInstallList(object):
Index: python-diskimage-builder/diskimage_builder/elements/svc-map/tests/test_data_merge.py
===================================================================
--- python-diskimage-builder.orig/diskimage_builder/elements/svc-map/tests/test_data_merge.py
+++ python-diskimage-builder/diskimage_builder/elements/svc-map/tests/test_data_merge.py
@@ -11,13 +11,24 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import imp
+import importlib.util
+import importlib.machinery
 import os
 from oslotest import base
 
+def load_source(modname, filename):
+    loader = importlib.machinery.SourceFileLoader(modname, filename)
+    spec = importlib.util.spec_from_file_location(modname, filename, loader=loader)
+    module = importlib.util.module_from_spec(spec)
+    # The module is always executed and not cached in sys.modules.
+    # Uncomment the following line to cache the module.
+    # sys.modules[module.__name__] = module
+    loader.exec_module(module)
+    return module
+
 module_path = (os.path.dirname(os.path.realpath(__file__)) +
                '/../extra-data.d/10-merge-svc-map-files')
-service_map = imp.load_source('service_map', module_path)
+service_map = load_source('service_map', module_path)
 
 
 class TestDataMerge(base.BaseTestCase):
